//+------------------------------------------------------------------+
//|                                                FXG_sHist2csv.mq4 |
//|                                                 FXGeneral, 2010 |
//|                                        http://www.fxgeneral.com/ |
//+------------------------------------------------------------------+
#property copyright "FXGeneral, 2010"
#property link      "http://www.fxgeneral.com/"

#property show_inputs
extern string ext="txt";
extern int last_bar=1;
extern int bars=610;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
Print(" .  ");
string smbs[];
double o,hi,l,c,v; 
int hFile = FileOpenHistory("symbols.raw", FILE_BIN|FILE_READ); if(hFile<0) return(-1);  //  symbols.raw
int nSmb=FileSize(hFile)/1936; //   ,   
ArrayResize(smbs, nSmb);
for(int i=0; i<nSmb; i++) 
{ 
smbs[i] = FileReadString(hFile, 12); FileSeek(hFile, 1924, SEEK_CUR); 

int h=FileOpen(""+smbs[i]+""+Period()+"."+ext+"",FILE_WRITE|FILE_CSV,",");
      for(int j=bars;j>=last_bar;j--)
      {
         o=iOpen(""+smbs[i]+"",Period(),j);
         c=iClose(""+smbs[i]+"",Period(),j);
         hi=iHigh(""+smbs[i]+"",Period(),j);
         l=iLow(""+smbs[i]+"",Period(),j);
         v=iVolume(""+smbs[i]+"",Period(),j);
         
         FileWrite(h,TimeToStr(Time[j],TIME_DATE),TimeToStr(Time[j],TIME_MINUTES),o,hi,l,c,v);
      }
  FileClose(h);

} 
Print(" ");
PlaySound("alert.wav");


   
//----
   return(0);
  }
//+------------------------------------------------------------------+